# Build Reactive Rest APIs with Spring WebFlux and Reactive MongoDB

## Requirements

1. Java - 1.8.x

2. Maven - 3.x.x

3. MongoDB - 3.x.x

## Steps to Setup

**1. Clone the application**

```bash
git clone https://gitlab.mynisum.com/vrajesh/spring-reactive-demo.git
```

**2. Build and run the app using maven**

```bash
cd spring-reactive-demo
mvn package
java -jar target/spring-reactive-demo-1.0-SNAPSHOT.jar
```

Alternatively, you can run the app without packaging it using -

```bash
mvn spring-boot:run
```

The server will start at <http://localhost:8080>.

## Exploring the Rest APIs

The application defines following REST APIs

```
1. GET /myTweets - Get All Tweets

2. POST /createTweet - Create a new Tweet

3. GET /myTweets/{id} - Retrieve a Tweet by Id

4. PUT /myTweets/{id} - Update a Tweet

5. DELETE /myTweets/{id} - Delete a Tweet

6. GET /stream/tweets - Stream tweets to a browser as Server-Sent Events
```

## Running integration tests

The project also contains integration tests for all the Rest APIs. For running the integration tests, go to the root directory of the project and type `mvn test` in your terminal.